void SetMonsterSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;

	static int name, cr, type, size, epic, hd, hdtype, tp, rwref, rwwil, rwzaeh, attr[6];
	static int ac, hdmin, hdmax, hdinc, hdinc2, init, speed, orgmin, orgmax, mix, treasure;
	static int att[6], num[6], red[6], dmga[6], dmgb[6], dmgc[6], atype[6], altern[2], feats[6], skills[7], skilll[7];
	static int spellcharpos, clericspellpos;
	static int valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		cr = GetValNumber(Vals, "CR", Number);
		type = GetValNumber(Vals, "Type", Number);
		size = GetValNumber(Vals, "Size", Number);
		epic = GetValNumber(Vals, "Epic", Number);
		hd = GetValNumber(Vals, "HD", Number);
		hdtype = GetValNumber(Vals, "HDT", Number);
		tp = GetValNumber(Vals, "TP", Number);
		rwref = GetValNumber(Vals, "Ref", Number);
		rwwil = GetValNumber(Vals, "Wil", Number);
		rwzaeh = GetValNumber(Vals, "Zaeh", Number);
		for (i = 0;i < 6;i++)
		{
			attr[i] = GetValNumber(Vals, GetAttributeName(i), Number);
		}

		ac = GetValNumber(Vals, "AC", Number);
		hdmin = GetValNumber(Vals, "HDMin", Number);
		hdmax = GetValNumber(Vals, "HDMax", Number);
		hdinc = GetValNumber(Vals, "HDInc", Number);
		hdinc2 = GetValNumber(Vals, "HDInc2", Number);
		init = GetValNumber(Vals, "Init", Number);
		speed = GetValNumber(Vals, "Speed", Number);
		orgmin = GetValNumber(Vals, "OrgMin", Number);
		orgmax = GetValNumber(Vals, "OrgMax", Number);
		mix = GetValNumber(Vals, "Mixed", Number);
		treasure = GetValNumber(Vals, "Treasur", Number);

		spellcharpos = GetValNumber(Vals, "SpellChar", Number);
		clericspellpos = GetValNumber(Vals, "ClericSpells", Number);

		for (i = 0;i < 6;i++)
		{
			sprintf(tempout, "Attack%d", i + 1);
			att[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Number%d", i + 1);
			num[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "AttRed%d", i + 1);
			red[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dA", i + 1);
			dmga[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dB", i + 1);
			dmgb[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Dmg%dC", i + 1);
			dmgc[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "Type%d", i + 1);
			atype[i] = GetValNumber(Vals, tempout, Number);
			if (i < 2) 
			{
				sprintf(tempout, "Altern%d", i + 1);
				altern[i] = GetValNumber(Vals, tempout, Number);
			}
			sprintf(tempout, "Feat%d", i + 1);
			feats[i] = GetValNumber(Vals, tempout, Number);
		}
		for (i = 0;i < 7;i++)
		{
			sprintf(tempout, "Skill%d", i + 1);
			skills[i] = GetValNumber(Vals, tempout, Number);
			sprintf(tempout, "SkillL%d", i + 1);
			skilll[i] = GetValNumber(Vals, tempout, Number);
		}
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in MonsterSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsMonster*) TargetStruct)->Name = Vals[name];

	FILE* fChkMonsterDesc;
	sprintf(tempout, "MonsterText\\%s", Vals[name]);
	fChkMonsterDesc = fopen(tempout, "r");
	if (fChkMonsterDesc == 0) {
		printf("Monster Description not found%s\n", Vals[name]);
		quitprog();
	} else {
		fclose(fChkMonsterDesc);
	}


	((clsMonster*) TargetStruct)->CR = atoi(Vals[cr]);

	((clsMonster*) TargetStruct)->Type = GetMonsterTypeNumber(Vals[type]);
	((clsMonster*) TargetStruct)->Size = GetSizeNumber(Vals[size]);

	((clsMonster*) TargetStruct)->Epic = atoi(Vals[epic]);
	((clsMonster*) TargetStruct)->HD = atoi(Vals[hd]);
	((clsMonster*) TargetStruct)->HDType = atoi(Vals[hdtype]);
	((clsMonster*) TargetStruct)->TPBonus = atoi(Vals[tp]);
	((clsMonster*) TargetStruct)->RWRef = atoi(Vals[rwref]);
	((clsMonster*) TargetStruct)->RWWil = atoi(Vals[rwwil]);
	((clsMonster*) TargetStruct)->RWZaeh = atoi(Vals[rwzaeh]);
	for (i = 0;i < 6;i++)
	{
		((clsMonster*) TargetStruct)->Attr[i] = atoi(Vals[attr[i]]);
	}

	((clsMonster*) TargetStruct)->AC = atoi(Vals[ac]);
	((clsMonster*) TargetStruct)->HDMin = atoi(Vals[hdmin]);
	((clsMonster*) TargetStruct)->HDMax = atoi(Vals[hdmax]);
	((clsMonster*) TargetStruct)->HDInc = atoi(Vals[hdinc]);
	((clsMonster*) TargetStruct)->HDInc2 = atoi(Vals[hdinc2]);
	((clsMonster*) TargetStruct)->Init = atoi(Vals[init]);
	((clsMonster*) TargetStruct)->Speed = atoi(Vals[speed]);
	((clsMonster*) TargetStruct)->OrgMin = atoi(Vals[orgmin]);
	((clsMonster*) TargetStruct)->OrgMax = atoi(Vals[orgmax]);
	((clsMonster*) TargetStruct)->Mixed = atoi(Vals[mix]);
	((clsMonster*) TargetStruct)->Treasure = atoi(Vals[treasure]);

	((clsMonster*) TargetStruct)->SpellChar = (char*) mallocl(strlen(Vals[spellcharpos]) + 1, "SetMonsterSource-SpellChar");
	strcpy(((clsMonster*) TargetStruct)->SpellChar, Vals[spellcharpos]);
	str_replace(':', ' ', ((clsMonster*) TargetStruct)->SpellChar);
	str_replace(';', 0, ((clsMonster*) TargetStruct)->SpellChar);

	((clsMonster*) TargetStruct)->ClericSpells = atoi(Vals[clericspellpos]);

	for (i = 0;i < 6;i++)
	{
		if (Vals[atype[i]][0] == 48)
		{
			break;
		}
		((clsMonster*) TargetStruct)->AttackBonus[i] = atoi(Vals[att[i]]);
		((clsMonster*) TargetStruct)->AttackNumber[i] = atoi(Vals[num[i]]);
		((clsMonster*) TargetStruct)->AttackRed[i] = atoi(Vals[red[i]]);
		((clsMonster*) TargetStruct)->DamageA[i] = atoi(Vals[dmga[i]]);
		((clsMonster*) TargetStruct)->DamageB[i] = atoi(Vals[dmgb[i]]);
		((clsMonster*) TargetStruct)->DamageC[i] = atoi(Vals[dmgc[i]]);
		((clsMonster*) TargetStruct)->AttackType[i] = Vals[atype[i]];

		if (i < 2) 
		{
			((clsMonster*) TargetStruct)->AlternateAttack[i] = atoi(Vals[altern[i]]);
		}
		else if (strcmp(Vals[atype[i]], "Slap") == 0)
		{
			((clsMonster*) TargetStruct)->AlternateAttack[i] = 3;
		}
		else
		{
			((clsMonster*) TargetStruct)->AlternateAttack[i] = 0;
		}
	}
	((clsMonster*) TargetStruct)->AttackCount = i;
	for (i = 0;i < 6;i++)
	{
		if (Vals[feats[i]][0] == 48)
		{
			break;
		}
		((clsMonster*) TargetStruct)->Feats[i] = GetFeatNumber(Vals[feats[i]], 1);
	}
	((clsMonster*) TargetStruct)->FeatCount = i;
	for (i = 0;i < 7;i++)
	{
		if (Vals[skills[i]][0] == 48)
		{
			break;
		}
		((clsMonster*) TargetStruct)->Skills[i] = GetSkillNumber(Vals[skills[i]], 1);
		((clsMonster*) TargetStruct)->SkillLevels[i] = atoi(Vals[skilll[i]]);
	}
	((clsMonster*) TargetStruct)->SkillCount = i;
}

void MonsterSourceExit()
{
	int i;
	for (i = 0;i < Source.MonsterSourceCount;i++)
	{
		freel(Source.MonsterSource[i].SpellChar);
	}
	delete[] Source.MonsterSource;
	freel(Source.MonsterCR);
}
